/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: start.S 972 2008-04-15 03:53:01Z ertl-honda $
 */
                
/*
 *   ͥѤΥȥåץ⥸塼(ARM)
 */
#define    TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"

    .text
    .code 32
    .align  2
    .global start
start:
    /*
     * ץå⡼ɤν
     * ѡХ⡼ɡFIQ/IRQػ
     */
    msr  cpsr, #(CPSR_SVC|CPSR_INTLOCK) 

#ifdef _MINDSTORMSNXT_

@
@ Do the remapping, if required, so that RAM is at address 0.
@
@  We read what is at address 0 and 2MB
@ We then invert what is at 2MB and read at 0 again
@ If address 0 has changed, then RAM is already at 0, so there is
@ no need to remap

    ldr  r0,=0x000000
    ldr  r2,=0x200000
    ldr  r3,[r0]
    ldr  r4,[r2]
    ldr  r5,=0xFFFFFFFF
    eor  r5,r4,r5
    str  r5,[r2]
    ldr  r5,[r0]
    str  r4,[r2]

    cmp  r3,r5
    bne  skip_remap_toggle

    ldr  r0,=(TADR_MC_BASE+TOFF_MC_RCR)
    ldr  r1,=1
    str  r1,[r0]

skip_remap_toggle:
    b    continue_boot

continue_boot:

@   Set up stacks etc.
@   We set up the irq and system stacks
@   We switch to system mode for further execution
@   NB Stacks should be 8-byte aligned for APCS
@   They should already be aligned, but we mask the values to make sure.
@
@ Set up Interrupt stack
    msr  CPSR_c,#(CPSR_IRQ|CPSR_INTLOCK)	/* @ IRQ mode, IRQ, FIQ off */
    ldr  r0, =__irq_stack__
    mov  sp,r0
    bic  sp,sp,#7    @ make sure it is 8-byte aligned

    msr  CPSR_c,#(CPSR_SVC|CPSR_INTLOCK) /* To System mode */

#endif	/* _MINDSTORMSNXT_ */

    /*
     * åݥ󥿤ȡե졼ݥ󥿤ν
     * sl(å¥쥸r10)ꤹɬפ뤫?
     * gccϥǥեȤǤ-mapcsʤΤɬפʤ
     */
    ldr  r0, =_kernel_istkpt
    ldr  sp, [r0]
    mov  fp, #0        /* ARM⡼ѥե졼ݥ(r11) */         
    mov  r7, #0        /* Thumb⡼ѥե졼ݥ    */

    /*
     * hardware_init_hookθƤӽФ 0Ǥʤ
     *
     * åȥϡɥ˰¸ɬפʽ
     * ϡhardware_init_hook ȤؿѰդ
     */
    ldr   r0, =hardware_init_hook
    cmp   r0, #0x00
    blne  hardware_init_hook

start_1:

#ifndef TOPPERS_OMIT_BSS_INIT
    /*
     *  bssΥꥢ
     */        
    ldr  r1, =__bss_start
    ldr  r2, =__bss_end
    cmp  r1,r2
    bhs  start_3
    mov  r0,#0
start_2:
    str  r0,[r1],#4
    cmp  r1, r2
    blo  start_2
#endif /* TOPPERS_OMIT_BSS_INIT */
       
start_3: 

#ifdef NXTBIOS
    /*
     *  vectorν(NXTBIOS)
     *  __vectors_load_start__  __vectors_load_end__ ޤǤ__vectors_ram_start__ ʹߤ
     *  ԡ
     */
    ldr  r1, =__vectors_load_start__
    ldr  r3, =__vectors_load_end__
    cmp  r1, r3
    bhs  start_32
    ldr  r2, =__vectors_ram_start__
start_31:
    ldr  r0, [r1],#4
    str  r0, [r2],#4
    cmp  r1, r3
    blo  start_31
start_32:

#endif /* NXTBIOS */

#ifndef TOPPERS_OMIT_DATA_INIT
    /*
     *  dataν(ROMб)
     *  __idata_start  __idata_end ޤǤ__data_start ʹߤ
     *  ԡ
     */
    ldr  r1, =__idata_start
    ldr  r3, =__idata_end
    cmp  r1, r3
    bhs  start_5
    ldr  r2, =__data_start
start_4:        
    ldr  r0, [r1],#4
    str  r0, [r2],#4
    cmp  r1, r3
    blo  start_4
#endif /* TOPPERS_OMIT_DATA_INIT */

    /*
     *  software_init_hook ƽФ0 Ǥʤ
     *
     *  եȥĶä˥饤֥ˤ˰¸ɬפʽ
     *  ϡsoftware_init_hook ȤؿѰդ
     *  褤
     */
start_5:
    ldr   r0, =software_init_hook
    cmp   r0, #0x00
    blne  software_init_hook

    /*
     * ͥư
     */
start_6:
    ldr r0, =sta_ker
    mov lr, pc
    bx  r0
