/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: ui.c,v 1.1 2009/08/14 13:55:29 roi Exp $
 */
/*****************************************************************************
 * FILE: ecrobot_base.c
 *
 * COPYRIGHT 2008 Takashi Chikamasa <takashic@cybernet.co.jp>
 *
 * <About leJOS NXJ>
 *  leJOS NXJ is a full firmware replacement of LEGO Mindstorms NXT and 
 *  designed for Java programming environment for the NXT 
 *  ( For more detailed information, please see: http://lejos.sourceforge.net/ )
 *  In the leJOS NXJ distribution, C source files for NXT platform layer is also
 *  included besides with the Java VM. The platform C source code is well
 *  structured, comprehensive, and achieved higher performance than the LEGO's
 *  one. Therefore, leJOS NXJ (platform) is also the best GCC based C/C++  
 *  development platform for NXT.
 *
 *  The contents of this file are subject to the Mozilla Public License
 *  Version 1.0 (the "License"); you may not use this file except in
 *  compliance with the License. You may obtain a copy of the License at
 *  http://www.mozilla.org/MPL/
 *
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *
 *  The Original Code is TinyVM code, first released March 6, 2000,
 *  later released as leJOS on September 23, 2000.
 *
 *  The Initial Developer of the Original Code is Jose H. Solorzano.
 *
 *  Contributor(s): see leJOS NXJ ACKNOWLEDGEMENTS .
 *
 *
 * <About TOPPERS OSEK>
 *  TOPPERS OSEK is an open source OSEK kernel and developed by TOPPERS project.
 *  TOPPERS(Toyohashi OPen Platform for Embedded Real-time Systems) has been managed 
 *  by a Non Profit Organization founded in Sep. 2003 and has been led by Professor
 *  Hiroaki Takada of Nagoya University in Japan. 
 *
 *  TOPPERS OSEK program is covered by the TOPPERS License as published
 *  by the TOPPERS PROJECT (http://www.toppers.jp/en/index.html).
 *
 *****************************************************************************/

#include "rtos.h"
#include "ecrobot_interface.h"

#define BTN1 0x01
#define BTN2 0x02
#define BTN3 0x04
#define BTN4 0x08
#define ENTER_PRESSED BTN1
#define STOP_PRESSED  BTN2
#define RUN_PRESSED   BTN3
#define EXIT_PRESSED  BTN4

#define FLASH_REQUEST   "Jumpin' Jack Flash"
#define FLASH_REQUEST_START_PAGE  (128 - 2)
#define FLASH_PAGE_SIZE 256

char flash_request_data[] = FLASH_REQUEST;

/*
 * display application main screen
 */
void show_main_screen(void)
{
	display_clear(0);
	display_goto_xy(0, 5);
	display_string("================");
	display_goto_xy(0, 6);
	display_string("<STP  ENTR  SKP>");
	display_goto_xy(0, 7);
	display_string("      EXIT      ");
	display_refresh();
}

/*
 * display status bar in the main screen
 * 
 * clear: 1(clear status bar), 0(not clear status bar)
 */
void display_status_bar(void)
{
	unsigned char *device_address = bluetooth_get_device_address();
	do{
		display_goto_xy(0, 0);
   		display_string("WAIT BLUETOOTH");
		display_goto_xy(0, 1);
   		display_string("  CONNECTION");
		display_goto_xy(0, 2);
   		display_string("BATT:");
   		display_unsigned(battery_voltage()/100, 0);
		display_goto_xy(0, 3);
		display_string("BD_ADDR:  ");
		display_string(bluetooth_get_pincode());
		if(bluetooth_get_connect_state(CONSOLE_PORTID) > BLUETOOTH_NO_INIT){
			int i;
			display_goto_xy(0, 4);
			for (i = 0; i < 7; i++)
			{
				display_hex(device_address[i], 2);
			}
		}
		display_refresh();
#ifdef TOPPERS_ATK1
		init_bluetooth_slave(bluetooth_get_pincode());
#endif	/* TOPPERS_ATK1 */
		systick_wait_ms(100);
	}while(bluetooth_get_connect_state(CONSOLE_PORTID) < BLUETOOTH_STREAM);

	/*
     *  ҂\
	 */
	display_goto_xy(0, 0);
	display_string("              ");
	display_goto_xy(0, 1);
	display_string("            ");
	display_refresh();
}

/*
 * read buttons status on the NXT. This function is assumed to be executed
 * every 10msec
 */
void check_NXT_buttons(VP_INT exinf)
{
	static old_button;
	int button;

	button = buttons_get() & 0xf;
	if(button == old_button){
		if (button == STOP_PRESSED)
		{
			display_clear(0);
			display_update();
			sil_dly_nse(10*1000*1000);
			nxt_lcd_power_down(); /* reset LCD hardware */
			sil_dly_nse(10*1000*1000);

			/* jump to the entry of application */
			kernel_exit();
		}
		else if (button == EXIT_PRESSED)
		{
			display_clear(0);
			display_update();
			sil_dly_nse(10*1000*1000);
			nxt_lcd_power_down(); /* reset LCD hardware */
			sil_dly_nse(10*1000*1000);
			nxt_avr_power_down(); /* send command to AVR to sleep ARM */
		}

		else if (button == (ENTER_PRESSED|STOP_PRESSED) &&
			     execution_mode() == EXECUTED_FROM_FLASH)
		{
			/* set flash request and shut down the NXT
		 	 * at the next start, NXT BIOS will be executed.
		 	 */
			flash_write_page(FLASH_REQUEST_START_PAGE, flash_request_data);
			display_clear(0);
			display_update();
			sil_dly_nse(10*1000*1000);
			nxt_lcd_power_down(); /* reset LCD hardware */
			sil_dly_nse(10*1000*1000);
			nxt_avr_power_down(); /* send command to AVR to sleep ARM */
		}
		else if (button == RUN_PRESSED)
		{
			if(bluetooth_get_connect_state(CONSOLE_PORTID) < BLUETOOTH_STREAM)
				bluetooth_set_connect_state(CONSOLE_PORTID, BLUETOOTH_CONNECT_ABORT);
		}
	}
	old_button = button;
}

