/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2009 by GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.c 2009-09-05 16:03:14 roi $
 */

/*
 * åװ¸⥸塼MINDSTORMS-NXTѡ
 */

#include "kernel_impl.h"
#include <sil.h>

/* Default handlers for the three general kinds of interrupts that the
 * ARM core has to handle. These are defined in irq.s, and just freeze
 * the board in an infinite loop.
 */
extern void default_isr(void);
extern void default_fiq(void);
extern void spurious_isr(void);
extern void nxt_toppers_stop(void);

/*
 * Ƴߤγ׵ػߥե饰ξ
 */
uint32_t idf;

/*
 * ߤγͥ٥ޥ
 */
PRI ipm;
 
/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿ
 */
uint32_t	bitpat_cfgint;

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
    int i;

    /*
     *  ARM¸ν
     */
    core_initialize();


    /*
     * ϻ˳װȽꤹ뤿SVR˳ֹ򥻥åȤ
     */
    /*
     * ߶ػ
     */
    sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_ICCR), ~0U);
	sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_FFDR), ~0U);
	sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_ICCR), ~0U);

    /*
     * EOICR򥻥å
     */
    sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_EOICR), 1U);

   /* Enable debug protection. This is necessary for JTAG debugging, so
    * that the hardware debugger can read AIC registers without
    * triggering side-effects.
    */
	sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_DCR), 1U);

   /* Set default handlers for all interrupt lines. */
	for (i = 0; i < 32; i++) {
		sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_SMR+i*4), 0);
		sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_SVR+i*4), (unsigned long)default_isr);
	}
	sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_SVR+INTNO_FIQ_PID*4), (unsigned long)default_fiq);
	sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_SVR+TOFF_AIC_SPU), (unsigned long)spurious_isr);

    /*
     * Ƴߤγ׵ػߥե饰ػ
     */
    idf = ~0U;

    /*
     * ͥ٥ޥ0
     */
    ipm = 0U;

    /*
     * Ƥγߤޥ
     */
    at91sam7s_disable_int(~0U);

    /*
     *  °ꤵƤ뤫Ƚ̤뤿ѿ롥
     */
    bitpat_cfgint = 0U;

#ifndef VECTOR_KERNEL
    /*
     *  㳰٥ơ֥سߥϥɥϿ
     */
    x_install_exc(EXCH_NO_IRQ, interrupt_handler);
    x_install_exc(EXCH_NO_UNDEF, undef_handler);
    x_install_exc(EXCH_NO_SWI, swi_handler);
    x_install_exc(EXCH_NO_PABORT, prefetch_handler);
    x_install_exc(EXCH_NO_DABORT, data_abort_handler);
    x_install_exc(EXCH_NO_FIQ, fiq_handler);
#endif /* VECTOR_KERNEL */

}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
    extern void    software_term_hook(void);
    void (*volatile fp)(void) = software_term_hook;

   /*
     *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
     *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
     *  Ǥ롥
     */
    if (fp != 0) {
        (*fp)();
    }

    /*
     *  ARM¸νλ
     */
    core_terminate();

    /*
     *  ٤Ƥγߤޥ롥
     */
    at91sam7s_disable_int(~0U);

    /*
     *  ȯĶ¸νλ
     */
    at91sam7s_exit();

    nxt_toppers_stop();
    while(1);
}

/*
 *  åȰ¸ʸ
 */
void
target_fput_log(char_t c)
{
}

/*
 *  ߥϥɥ
 *
 *  ֹ inhno γߥϥɥεưϤ inthdr ꤹ롥
 */
void
x_define_inh(INHNO inhno, FP inthdr)
{
    assert(inhno <= TMAX_INTNO);
	sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_SVR+inhno*4), (unsigned long)inthdr);
}

/*
 *  ׵饤°
 *
 *  ASPͥǤѤꤷơѥ᡼顼ϥǥ
 *  Ƥ롥FI4ͥѤˤϡ顼֤褦ˤ٤
 *  Ǥ
 *
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
    assert(VALID_INTNO(intno));
    assert(TMIN_INTPRI <= intpri && intpri <= TMAX_INTPRI);

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ
	 */
	bitpat_cfgint |= INTNO_BITPAT(intno);

    /*
     * äߤػߤ
     */
    x_disable_int(intno);

    /*
     * ٥ȥꥬ/åȥꥬ
     * IRQΤߥݡȤ
     */
    uint32_t smr_val;

    if((intatr & TA_POSEDGE) != 0U) {
        /*
         * ݥƥ֥å
         */
        smr_val = AIC_SRCTYPE_EXT_POSITIVE_EDGE;
    }else if((intatr & TA_HIGHLEVEL) != 0U) {
        /*
         * ϥ٥ȥꥬ
         */
        smr_val = AIC_SRCTYPE_EXT_HIGH_LEVEL ;
    }else if((intatr & TA_EDGE) != 0U) {
        /*
         * åȥꥬ
         */
        smr_val = AIC_SRCTYPE_INT_EDGE_TRIGGERED;
    }else{
        /*
         * ٥ȥꥬ
         */
        smr_val = AIC_SRCTYPE_INT_LEVEL_SENSITIVE;
    }

    sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_SMR+intno*4U), smr_val|INT_IPM(intpri));

    if ((intatr & TA_ENAINT) != 0U){
        (void)x_enable_int(intno);
    }
}


#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 * ̤γߤäν
 */
void
default_int_handler(void){
    syslog_0(LOG_EMERG, "Unregistered Interrupt occurs.");
    target_exit();
}
#endif /* OMIT_DEFAULT_INT_HANDLER */
