/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2009 by GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.h 2009-09-06 11:45:08 roi $
 */

/*
 *  åȰ¸⥸塼MINDSTORMSNXTѡ
 *
 *  ͥΥåȰ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  åװ¸⥸塼AT91SAM7S+MINDSTROMSNXTѡ
 */
/*
 *  åץƥΥϡɥ񸻤
 */
#include "at91sam7s.h"
#include "mindstormsnxt.h"

/*
 *  ٥롼򥫡ͥǻĤ
 */
#define VECTOR_KERNEL

/*
 *  ٥롼ʤΥ٥ɥ쥹Ƭ
 */ 
#define VECTOR_START  0x00

/*
 * Ԥ̿
 */
#define ASM_TARGET_WAIT_INTERRUPT nop

/*
 *  ASPͥưΥޥåפȴϢ
 */
#define RAM_START       SRAM_BASE_ADDRESSS
#define RAM_SIZE        SRAM_SIZE

#define FIQ_DATA_SIZE   256U

/*
 *  ǥեȤ󥿥ƥѤΥåΰ
 */
#define DEFAULT_ISTKSZ      0x1000U   /* 4KB */
#define DEFAULT_ISTK        (void *)(RAM_START+RAM_SIZE-FIQ_DATA_SIZE - DEFAULT_ISTKSZ)

                                                   
/*
 *  ԤΤSILΥåȰ¸
 */
#define SIL_DLY_TIM1    420
#define SIL_DLY_TIM2    195

/*
 *  ߥϥɥֹ˴ؤ
 */ 
#define TMIN_INHNO 0U
#define TMAX_INHNO 31U
#define TNUM_INH   32U

/*
 *  ֹ˴ؤ
 */ 
#define TMIN_INTNO 0U
#define TMAX_INTNO 31U
#define TNUM_INT   32U

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ֹϰϤȽ
 *
 *  ӥåȥѥΤưפˤ뤿ˡ8Ϸ֤ˤʤäƤ롥
 */
#define VALID_INTNO(intno) (TMIN_INTNO <= (intno) && (intno) <= TMAX_INTNO)
#define VALID_INTNO_DISINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_ATTISR(intno)   VALID_INTNO(intno)

/*
 *  ߥϥɥ
 */
extern void  x_define_inh(INHNO inhno, FP int_entry);

/*
 *  ߥϥɥνޥ
 *
 */
/*  CѤΥ٥  */
#define	_INT_ENTRY(inthdr)	_kernel_##inthdr##_entry
#define INT_ENTRY(inhno, inthdr)    _INT_ENTRY(inthdr)

/*
 *ߤޥ
 *ʳװ˰ۤʤʬ
 *
 *ѥ᡼
 *	entryΥ٥
 *inthdrC롼δؿ̾Ƭ'_'դʤ
 *
 *lr-4ϥɥ쥹
 *쥸
 *r0r3쥸
 *
 */
#define	__INTHDR_ENTRY(entry, inhno_num, inthdr)  \
extern void _INT_ENTRY(inthdr)(void) throw();	\
asm(".text					\n"\
"	.align 2				\n"\
"   .arm                    \n"\
"	.global "#entry"		\n"\
#entry":					\n"\
"   sub   lr,lr,#4          \n"	/* Save registers on stack */\
"	stmfd sp!,{lr}          \n"\
"	mrs   lr,spsr			\n"\
"	stmfd sp!,{lr}          \n"\
	/* Acknowledge the IVR for debugging to support Protected Mode */\
"	ldr   lr,=0xFFFFF100	\n" /* TADR_AIC_BASE+TOFF_AIC_IVR */\
"	str   lr,[lr]			\n"\
    /* ư⡼(ѡХ⡼) */\
"	msr   cpsr_fc,#0xd3     \n"	/* (CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT)*/\
"	stmfd sp!, {r0-r3,ip,lr,pc}	\n"\
    /* spsrϤ뤿IRQ⡼ɤ */\
"	msr   cpsr_fc,#0xd2     \n"	/* (CPSR_IRQ|CPSR_FIQ_BIT|CPSR_IRQ_BIT) */\
"	ldmfd sp!, {r1}         \n"	/* restore spsr */\
"	ldmfd sp!, {r0}         \n"	/* restore lr */\
    /* ѡХ⡼ɤ */\
"	and   r2,r1, #0x40      \n"	/* (CPSR_FIQ_BIT) */\
"	orr   r2,r2, #0x93      \n"	/* (CPSR_SVC|CPSR_IRQ_BIT) */\
"	msr   cpsr_fc,r2        \n"\
"	str   r0,[sp,#0x18]     \n"	/* lr into pc */\
"	stmfd sp!,{r1}          \n"	/* save spcr */\
"   mov   lr, sp            \n"	/* λΥåΤ */\
    /* ¿ųߤȽ */\
"	ldr   r2, =_kernel_excpt_nest_count	\n"\
"	ldr   r3,[r2]           \n"\
"	add   r0,r3,#1          \n"\
"	str   r0,[r2]           \n"\
"	cmp   r3,#0x00          \n"\
"   bne   "#entry"_1		\n"\
    /* ܤ㳰ʳߡˤʤ饹åѹ */\
"   ldr   r0, =_kernel_istkpt \n"\
"   ldr   sp, [r0]          \n"\
#entry"_1:					\n"\
"   stmfd sp!, {lr}         \n"	/* ѤΥåݥ󥿤¸ */\
    /*  װγͥ٤(ǥ)ͥ٥ޥ򥻥å */\
    /*  롥ޤκݡϥɥ¹(ǥ)ͥ٥ޥ   */\
    /*  ¸롥*/\
"   ldr   r3, ="#inhno_num" \n"\
"   ldr   r0, =_kernel_inh_ipm_tbl \n"	/* ͥ٤ */\
"   ldr   r1, [r0, r3, lsl #2] \n"	/* r1<-ͥ   */\
"   ldr   r0, =_kernel_ipm  \n"	/* ȯγͥ٥ޥ򥹥å¸ */\
"   ldr   r2, [r0]          \n"\
"   stmfd sp!,{r2}          \n"\
"   str   r1, [r0]          \n" /* (ǥ)ͥ٥ޥ򥻥å */\
    /* ϡɥ(IRC)ϳߤդ塤ߤ˱ͥ٥ޥ */\
    /* 򥻥åȤ롥Τ᥽եȥŪˤä˽ϹԤɬפϤʤ  */\
    /* եȥŪ(ǥ)ͥ٥ޥ夲ݤˤϡ      */\
    /* ͥ٥ޥ˱Ƴ׵ػߥե饰ˤߤػߤ*/\
    /* ߥϥɥεưϤ */\
"	ldr   r0,="#inthdr"     \n"\
"   b     irq_handler       " )

/*  __INTHDR_ENTRY()ޥޤ  */

/*
 *  ߥϥɥνޥ
 *
 */
#define _INTHDR_ENTRY(entry, inhno_num, inthdr)	  \
	__INTHDR_ENTRY(entry, inhno_num, inthdr);

#define INTHDR_ENTRY(inhno, inhno_num, inthdr) \
	_INTHDR_ENTRY(_INT_ENTRY(inthdr), inhno_num, inthdr)

/*
 *  TOPPERSɸ߽ǥμ¸
 */

/*
 *  ͥ٥ޥγɽɽѴ
 *
 *  ֥Υե뤫饤󥯥롼ɤΤˡ
 *  㥹ȤʤѰդƤ롥
 */
#ifndef TOPPERS_MACRO_ONLY
#define EXT_IPM(iipm)    ((PRI)(-iipm))     /* ɽɽ */
#define INT_IPM(ipm)     ((uint8_t)(-ipm))  /* ɽɽ */
#else /* TOPPERS_MACRO_ONLY */
#define EXT_IPM(iipm)    (-iipm)            /* ɽɽ */
#define INT_IPM(ipm)     (-ipm)             /* ɽɽ */
#endif /* TOPPERS_MACRO_ONLY */

/*
 * Ƴߤγ׵ػߥե饰ξ
 */
extern uint32_t idf;

/*
 *  ͥ٥ޥ饤֥
 *
 *  AT91SAM7Sϳͥ٥ޥIRCǥϡɥŪ˻Ĥ
 *  եȥ¦ͤɤ߽񤭤Ǥʤᡤ׵ػߥե
 *  ˤͥ٥ޥ¸
 */

/*
 *  ߤγͥ٥ޥ
 */
extern PRI ipm;

/*
 *  ͥ٥ޥ˥åȤ롤׵ػߥե饰
 *  Υơ֥
 */
extern const uint32_t ipm_mask_tbl[8];

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  IPMimp_mask_tblΥǥåѴޥ
 */
#define INDEX_IPM(ipm)  (-(ipm))

#ifndef TOPPERS_MACRO_ONLY

/*
 *  (ǥ)ͥ٥ޥ
 * 
 *  ꤵ줿ͥ٤ꤵ줿׵ػߥե饰Υơ֥ͤȡʥ
 *  Ρ˳Ƴߤγ׵ػߥե饰ξ֤ݻѿͤȤ
 *  ORIRCγ׵ػߥե饰˥åȤꤷͥ٤ѿ
 *  ipm¸롥
 */
Inline void
x_set_ipm(PRI intpri)
{
    uint32_t ipm_mask = ipm_mask_tbl[INDEX_IPM(intpri)];

    /*
     *  AT91SAM7Sγߥȥϥ֥͡쥸
     *  ꥢ쥸뤿ᡤöƤγߤػߤƤ顤
     *  γߤΤߵĤɬפ
     */
    /* ߶ػ */
    at91sam7s_disable_int(~0U);

    /* ޥꤵƤʤߤΤߵ */
    at91sam7s_enable_int(~(ipm_mask|idf));

    ipm = intpri;
}

#define t_set_ipm(intpri) x_set_ipm(intpri)
#define i_set_ipm(intpri) x_set_ipm(intpri)

/*
 *  (ǥ)ͥ٥ޥλ
 *
 *  ipm֤ͤ
 */
Inline PRI
x_get_ipm(void)
{
    return(ipm);
}

#define t_get_ipm() x_get_ipm()
#define i_get_ipm() x_get_ipm()

/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿ
 */
extern uint32_t	bitpat_cfgint;

/*
 * ʥǥΡ˳׵ػߥե饰Υå
 *
 *  ꤵ줿ֹγ׵ػߥե饰ΥåȤơߤ
 *  ػߤ롥ޤʥǥΡ˳׵ػߥե饰idf
 *  ӥåȤ򥻥åȤ롥
 *  ׵ޥ뵡ǽ򥵥ݡȤƤʤˤϡfalse֤
 */
Inline bool_t
x_disable_int(INTNO intno)
{
    if ((bitpat_cfgint & INTNO_BITPAT(intno)) == 0U) {
        return(false);
    }
    at91sam7s_disable_int(INTNO_BITPAT(intno));
    idf |= INTNO_BITPAT(intno);
    return(true);
}

#define t_disable_int(intno)  x_disable_int(intno)
#define i_disable_int(intno)  t_disable_int(intno)

/* 
 * (ǥ)׵ػߥե饰β
 *
 * ꤵ줿ֹγ׵ػߥե饰Υꥢơߤ
 * Ĥ롥ޤʥǥΡ˳׵ػߥե饰idf
 * ӥåȤ򥯥ꥢ롥
 * ׵ޥ뵡ǽ򥵥ݡȤƤʤˤϡfalse֤
 */
Inline bool_t
x_enable_int(INTNO intno)
{
    if ((bitpat_cfgint & INTNO_BITPAT(intno)) == 0U) {
        return(false);
    }    
    at91sam7s_enable_int(INTNO_BITPAT(intno));
    idf &= ~INTNO_BITPAT(intno);
    return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 * ׵Υꥢ
 */
Inline void
x_clear_int(INTNO intno)
{
    at91sam7s_clear_int(INTNO_BITPAT(intno));
}

#define t_clear_int(intno) x_clear_int(intno) 
#define i_clear_int(intno) x_clear_int(intno) 


/*
 *  ׵Υå
 */
Inline bool_t
x_probe_int(INTNO intno)
{
    return(at91sam7s_probe_int(INTNO_BITPAT(intno)));
}

#define t_probe_int(intno) x_probe_int(intno)
#define i_probe_int(intno) x_probe_int(intno)

/*
 *  ׵饤°
 *
 */
extern void    x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *  ߥϥɥɬפIRC
 *
 *  AT91SAM7SǤϡɬפʽϤʤ
 */
Inline void
i_begin_int(INTNO intno)
{
    
}

/*
 *  ߥϥɥνиɬפIRC
 *
 *  AT91SAM7SǤϡɬפʽϤʤ
 */
Inline void
i_end_int(INTNO intno)
{
    
}

/*
 *  åȥƥ¸ν
 */
extern void target_initialize(void);

/*
 *  åȥƥνλ
 *
 *  ƥλ˻Ȥ
 */
extern void target_exit(void) NoReturn;

/*
 *  ߥϥɥchip_support.S
 */
extern void interrupt_handler(void);

/*
 *  ̤γߤäν
 */
extern void default_int_handler(void);

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ¸⥸塼ARMѡ
 */
#include "arm_gcc/common/core_config.h"

#endif /* TOPPERS_TARGET_CONFIG_H */
