/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2009 by GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_support.S 2009-09-05 15:46:56 roi $
 */

/*
 *  åװ¸⥸塼 ֥MINDSTORMS-NXTѡ
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"

/*
 *  ٥Υåȥƥ¸ν
 *
 *  ȥåץ⥸塼ǡ˸ƤӽФ롥          
 */
    .text
    .align 2
    .global hardware_init_hook
hardware_init_hook:
@   MC_FMR:
@   Set up flash memory accessing and memory for 48 MHz FMCN = 50)
@   2 wait states (FWS = 1)
@   No special flags
@

skip_remap_toggle:
    ldr r0,=(TADR_MC_BASE+TOFF_MC_FMR)
    ldr r1,=((72 << MC_FMR_FMCN_SHIFT) | MC_FMR_FWS_1FWS)
    str r1,[r0]

@
@   Disable watchdog
@   Set MDT_MR disable bit. 
@   Note: probably want to set this differently at some stage...
@
    ldr r0,=(TADR_WDT_BASE+TOFF_WDT_MR)
    ldr r1,=WDT_MR_WDDIS
    str r1,[r0]

@
@   Set up PLL & clock source
@   The main crystal is 18.432 MHz
@   We want as close as we can get to 48MHz
@   We use the PLL to generate 18432000 / 14 * 73 = 96109714
@   We then divide this by 2

@ Start main osc

    ldr r0,=(TADR_PMC_BASE+TOFF_CKGR_MOR)
    ldr r1,=((6 << CKGR_MOR_OSCOUNT_SHIFT) | CKGR_MOR_MOSCEN)
    str r1,[r0]

    ldr r0,=(TADR_PMC_BASE+TOFF_PMC_SR)
wait_MOSCS:
    ldr r1,[r0]
    ands r1,r1,#PMC_SR_MOSCS
    beq wait_MOSCS

@ set up PLL
    ldr r0,=(TADR_PMC_BASE+TOFF_CKGR_PLLR)
    ldr r1,=0x00481C0E
    str r1,[r0]

    ldr r0,=(TADR_PMC_BASE+TOFF_PMC_SR)
wait_pll_lock:
    ldr r1,[r0]
    ands r1,r1,#PMC_SR_LOCK
    beq wait_pll_lock

    ldr r0,=(TADR_PMC_BASE+TOFF_PMC_SR)
wait_MCLK_Ready0:
    ldr r1,[r0]
    ands r1,r1,#8
    beq  wait_MCLK_Ready0

@ Set up master clock to use clock div 2
    ldr r0,=(TADR_PMC_BASE+TOFF_PMC_MCKR)
    ldr r1,=PMC_MCKR_PRES_CLK_2
    str r1,[r0]

    ldr r0,=(TADR_PMC_BASE+TOFF_PMC_SR)
wait_MCLK_Ready1:
    ldr r1,[r0]
    ands r1,r1,#8
    beq  wait_MCLK_Ready1

@ Set up master clock to use PLL clock div 2
    ldr r0,=(TADR_PMC_BASE+TOFF_PMC_MCKR)
    ldr r1,=(PMC_MCKR_PRES_CLK_2 | PMC_MCKR_CSS_PLL_CLOCK)
    str r1,[r0]

    ldr r0,=(TADR_PMC_BASE+TOFF_PMC_SR)
wait_MCLK_Ready2:
    ldr r1,[r0]
    ands r1,r1,#8
    beq  wait_MCLK_Ready2

    bx    lr

    .text
    .align 2
    .global software_init_hook
software_init_hook:
    bx    lr

    .text
    .align 2
    .global software_term_hook
software_term_hook:
    bx    lr


/*
 * ߥϥɥ
 *
 * IRQ 㳰٥ƤӽФ
 * r0 handler address r3 inthdr_num
 */
    .text
    .align 2
    .global irq_handler
irq_handler:
    stmfd sp!,{r3}             /* inhno ¸  */

    /*
     * ߵ 
     */
    msr   cpsr, #(CPSR_SVC)

#ifdef LOG_INH_ENTER
    stmfd sp!,{r0}
    mov   r0, r3         /* inhno ѥ᡼    */
    bl    log_inh_enter  /* log_inh_enterƤӽФ */
    ldmfd sp!,{r0}
#endif /* LOG_INH_ENTER */

    /* 
     * ߥϥɥθƤӽФ
     */
    mov   lr, pc
    bx    r0

    ldmfd sp!,{r0}       /* inhno   */
#ifdef LOG_INH_LEAVE
    bl    log_inh_leave  /* log_inh_leaveƤӽФ */
#endif /* LOG_INH_LEAVE */

    /*
     * ͥγߤػߤ
     */
    mrs   r2,cpsr
    and   r2,r2,#CPSR_FIQ_BIT
    orr   r2,r2,#(CPSR_SVC|CPSR_IRQ_BIT)
    msr   cpsr,r2

    /*
     * ߥꥢ
     */
    ldr   r3, =TADR_AIC_BASE
    mov   r0, #0
    str   r0, [r3, #TOFF_AIC_EOICR]

    b     target_ret_int


/*
 * åȰ¸㳰
 */
    .text
    .global target_exc_handler
target_exc_handler:
    /*
     *  㳰¹ԤΥ⡼ɡʥѡХ⡼ɡˤ
     *  ߥå֡CPUå֤CPU㳰ȯ
     *  ֤Ѿ롥
     */
    msr   cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT) 
    str   r0, [sp, #0x18] /* Ϥ򥹥å */
    stmfd sp!, {r1}       /* spsr򥹥å¸ */    
    mov   lr, sp          /* λΥåΤ */

    ldr   r0, =ipm        /* ȯγͥ٥ޥ򥹥å¸ */
    ldr   r1, [r0]
    stmfd sp!, {r1}

    /* 
     * ƥȽΤᡤexcpt_nest_count 򥹥å¸
     * å¸ߤexcpt_nest_count-1ȼǤ뤬
     * åѤǤǥХåԤ䤹Τǡå
     * ¸롥
     */
    ldr   r0, =excpt_nest_count
    ldr   r1, [r0]
    stmfd sp!, {r1}

    mov   r3,  sp         /* 㳰ե졼Ϥ¸ */

    /*
     *  ¿ųߤȽ
     */
    ldr   r0, =excpt_nest_count
    ldr   r1, [r0]
    add   r1, r1, #1
    str   r1, [r0]
    cmp   r1, #1
    bne   target_exc_handler_1

    /* 
     * ܤμ¹Ԥʤ饹åѹ
     */
    ldr  r0, =_kernel_istkpt
    ldr  sp, [r0]

target_exc_handler_1:
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /* 
     * ȯγͥ٥ޥ򥹥å¸ 
     * ߥϥɥȽи롼ͭ뤿¸
     */
    ldr   r0, =ipm
    ldr   r1, [r0]
    stmfd sp!, {r1}

    /*
     *  CPU㳰ϥɥεưϤ
     */
    ldr   r0, =exch_tbl        /* ߥϥɥơ֥ɤ߽Ф */
    ldr   r1, [r0, r2, lsl #2] /* r1<-㳰ϥɥ                 */

    stmfd sp!,{r2}      /* excno ¸ */
    /* 
     * ߵ 
     * CPUå֡ߥå֤ϷѾ
     */         
    ldr   r0, [lr]
    and   r0, r0, #(CPSR_IRQ_BIT|CPSR_FIQ_BIT)
    orr   r0, r0, #(CPSR_SVC)
    msr   cpsr, r0

#ifdef LOG_EXC_ENTER
    stmfd sp!,{r1,r3}
    mov   r0, r2         /* excno ѥ᡼    */
    bl    log_exc_enter  /* log_exc_enterƤӽФ */
    ldmfd sp!,{r1,r3}
#endif /* LOG_EXC_ENTER */

    /* 
     * CPU㳰ϥɥθƤӽФ
     *
     * 㳰ե졼ƬȤϤ
     */        
    mov   r0, r3
    mov   lr, pc
    bx    r1

    ldmfd sp!,{r0}       /* excno   */
#ifdef LOG_EXC_LEAVE
    bl    log_exc_leave  /* log_exc_leaveƤӽФ */
#endif /* LOG_EXC_LEAVE */

/*
 * åȰ¸㳰ߤνи
 *
 */

    .global target_ret_exc
target_ret_exc:
    /*
     * ͥγߤػߤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT)

    .global target_ret_int
target_ret_int:
    /*
     * ͥ٥ޥ򸵤᤹
     */
    ldmfd sp!, {r1}             /* γͥ٥ޥ */
    ldr   r0, =ipm              /* ͥ٥ޥ     */
    str   r1, [r0]
    rsb   r1, r1, #0            /* ǥåȤ뤿ȿž   */
    ldr   r0, =ipm_mask_tbl     /* (ǥ)γͥ٤Τ¸뤿 */
    ldr   r2, [r0, r1, lsl #2]  /* ׵ػߥե饰 */
    ldr   r0, =idf              /* Ƴߤγ׵ػߥե饰ξ֤ */
    ldr   r1, [r0]
    /*
     * Ƴߤγ׵ػߥե饰ξ֤(ǥ)γͥ٤Τ¸
     * γ׵ػߥե饰ξ֤ORȤꡤ뤳Ȥˤꡤ
     * IRCγߵĥ쥸ؤͤꤹ롥
     */
    ldr   r0, =TADR_AIC_BASE    /* äߤγ׵ޥ */
    mvn   lr, #0
    str   lr, [r0, #TOFF_AIC_IDCR]
    orr   r1, r1, r2            /* ޥꤵƤʤߤε */
    mvn   r1, r1                /* ͤ */
    str   r1, [r0, #TOFF_AIC_IECR]

    /*
     * åݥ󥿤
     */
    ldmfd sp!, {r2}             /* Υåݥ󥿤 */
    mov   sp, r2

    /*
     * νARM¸Ǽ¹
     */
    b     ret_int

    .global nxt_toppers_stop
nxt_toppers_stop:
    msr cpsr, #(CPSR_IRQ_BIT | CPSR_FIQ_BIT | CPSR_SVC)
    ldr   r0, =TADR_PIT_BASE
    mov   r1, #0
    str   r1, [r0, #TOFF_PIT_MR]
    b     start

@
@	ISRs
@
@
    .global spurious_isr
    .global default_isr
    .global default_fiq
default_fiq:
spurious_isr:
default_isr:
    b     default_isr


