/**
 ******************************************************************************
 **	t@C : sample.c
 **
 **	Tv       : 2֓|UqCg[X{bgTOPPERS/JSPpTvvO
 **
 ******************************************************************************
 **/
#include <s_services.h>
#include "control.h"
#include "kernel_id.h"
#include "ecrobot_base.h"
#include "ecrobot_interface.h"
#include "balancer.h"	/* |Uqpwb_t@C */

/* L̃p[^̓ZT/ɍ킹ă`[jOKv܂ */
#define GYRO_OFFSET         589 /* WCZTItZbgl(px0[deg/sec])  */
#define WHITE               500 /* F̌ZTl */
#define BLACK		        700 /* F̌ZTl */
#define DEFFORECOUNT        10	/* Oiޗv(*40ms) */
#define DEFTURNCOUNT        4	/* ^[v(40ms) */
#define STOPWAIT            20	/* ~܂ł̎(*40ms) */
#define TURN_BASE           0	/* TURN̊ */

#define TAIL_ANGLE_STAND_UP 100 /* S~̊px[x] */
#define TAIL_ANGLE_DRIVE      0 /* oXs̊px[x] */
#define P_GAIN             2.5F /* S~p[^W */
#define PWM_ABS_MAX          60 /* S~p[^PWM΍ől */

static int gyro_offset;
static signed char forward;		/* Oi: -100(i)`100(Oi)   */
static signed char turn;		/* 񖽗: -100()`100(E) */
static char mstate;				/* ŝ̏ */
static char keystate;			/* ^b`ZT[̏ */

//*****************************************************************************
// ֐ : tail_control
//   : angle ([^ڕWpx[x])
// Ԃl : 
// Tv : s̊S~p[^̊px
//*****************************************************************************
static void tail_control(signed int angle)
{
	float pwm = (float)(angle - nxt_motor_get_count(NXT_PORT_A))*P_GAIN; /* ᐧ */
	/* PWMo͖Oa */
	if(pwm > PWM_ABS_MAX)
		pwm = PWM_ABS_MAX;
	else if(pwm < -PWM_ABS_MAX)
		pwm = -PWM_ABS_MAX;
	nxt_motor_set_speed(NXT_PORT_A, (signed char)pwm, 1);
}

//*****************************************************************************
// TASK			: cyc0
// DESCRIPTION 	: 4msec periodical Task handler
//*****************************************************************************
void cyc0(VP_INT exinf)
{
	isig_sem(EVT_SEM);
}

//*****************************************************************************
// ^XN	: TaskMain
// Tv		: C^XN
//*****************************************************************************
void TaskMain(VP_INT exinf)
{
	signed char pwm_L, pwm_R; /* E[^PWMo */
	int gyro_value;

	mstate = MWAIT;
	while(mstate != MRUNNING){ /* ^b`ZTҋ@ */
		tail_control(TAIL_ANGLE_STAND_UP);	/* S~ppxɐ */
		dly_tsk(10);
	}
	ecrobot_set_light_sensor_active(NXT_PORT_S3);       /* ZTԐFLEDON */
	gyro_offset = ecrobot_get_gyro_sensor(NXT_PORT_S1);
	syslog(LOG_NOTICE, "gyro offset def=%d cur=%d", GYRO_OFFSET, gyro_offset);

	balance_init();						/* |Uq䏉 */
	nxt_motor_set_count(NXT_PORT_C, 0); /* [^GR[_Zbg */
	nxt_motor_set_count(NXT_PORT_B, 0); /* E[^GR[_Zbg */
	forward = 0;						/* Oi */
	turn = 0;
	sta_cyc(CYC0);
	while(mstate < MPREWAIT){
		if(mstate == MRUNNING){
			tail_control(TAIL_ANGLE_DRIVE); /* oXsppxɐ */
		}
		else if(mstate == MSTOP1){
			nxt_motor_set_count(NXT_PORT_A, 0);	/* S~p[^GR[_Zbg */
			mstate = MSTOP2;
		}
		else{
			tail_control(TAIL_ANGLE_STAND_UP);	/* S~ppxɐ */
			forward = 0;						/* ~ */
			turn = 0;
			gyro_value = ecrobot_get_gyro_sensor(NXT_PORT_S1);
			if(mstate == MSTOP3 && gyro_value <= gyro_offset){
				syslog_1(LOG_NOTICE, "stop gyro value = %d", gyro_value);
				break;
			}
		}

		/* |Uq(forward = 0, turn = 0ŐÎ~oX) */
		balance_control(
			(float)forward,                              /* Oi                 */
			(float)(turn+TURN_BASE),                     /* 񖽗                   */
			(float)ecrobot_get_gyro_sensor(NXT_PORT_S1), /* WCZTl           */
			(float)gyro_offset,                          /* WCZTItZbgl */
			(float)nxt_motor_get_count(NXT_PORT_C),      /* [^]px[deg]      */
			(float)nxt_motor_get_count(NXT_PORT_B),      /* E[^]px[deg]      */
			(float)ecrobot_get_battery_voltage(),        /* obed[mV]           */
			&pwm_L,  /* [^PWMo͒l */
			&pwm_R); /* E[^PWMo͒l */
		ecrobot_set_motor_speed(NXT_PORT_C, pwm_L);      /* [^PWMo̓Zbg */
		ecrobot_set_motor_speed(NXT_PORT_B, pwm_R);      /* E[^PWMo̓Zbg */

		wai_sem(EVT_SEM);	/* 4MS҂ */
	}

	ecrobot_set_motor_speed(NXT_PORT_C, 0);      /* [^PWMo̓Zbg */
	ecrobot_set_motor_speed(NXT_PORT_B, 0);      /* E[^PWMo̓Zbg */
	ecrobot_sound_tone(1000, 200, 50);
	act_tsk(TASK0);
}

//*****************************************************************************
// ^XN	: TaskDisp
// Tv		: \^XN
//*****************************************************************************
void TaskDisp(VP_INT exinf)
{
	T_SERIAL_RPOR rpor;
	UB buf[4];
	ER ercd;
	int distance;
	int wtime = 0;
	int fore_count = 0;
	int turn_count = 0;
	char key;

	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG));
	syscall(serial_ctl_por(CONSOLE_PORTID,	(IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV)));
	show_splash_screen();
	ecrobot_init_nxtstate();
	ecrobot_init_sensors();
	ecrobot_init_sonar_sensor(NXT_PORT_S2);
	show_main_screen();
	display_status_bar();
	ecrobot_sound_tone(1000, 200, 50);
	mstate = MINIT;
	keystate = ecrobot_get_touch_sensor(NXT_PORT_S4);
	nxt_motor_set_count(NXT_PORT_A, 0);		/* S~p[^GR[_Zbg */
	act_tsk(TASK0);
	while(1){
		ecrobot_poll_nxtstate();
		distance = ecrobot_get_sonar_sensor(NXT_PORT_S2);
		ercd = serial_ref_por(CONSOLE_PORTID, &rpor);
		if(ercd == E_OK && rpor.reacnt){
			serial_rea_dat(CONSOLE_PORTID, buf, 1);
			if(buf[0] == 'i'){
				if(forward < 100)
					forward += 20;
				fore_count = DEFFORECOUNT;
				syslog(LOG_NOTICE, "[foreword]foreward[%d] turn[%d]", (int)forward, (int)turn);
			}
			else if(buf[0] == 'm'){
				if(forward > -100)
					forward -= 20;
				fore_count = DEFFORECOUNT;
				syslog(LOG_NOTICE, "[backword]foreward=%d turn[%d]", (int)forward, (int)turn);
			}
			else if(buf[0] == 'k'){
				if(turn > -60)
					turn -= 30;
				turn_count = DEFTURNCOUNT;
 				syslog(LOG_NOTICE, "[right]foreward=%d turn[%d]", (int)forward, (int)turn);
			}
			else if(buf[0] == 'j'){
				if(turn < 60)
					turn += 30;
				turn_count = DEFTURNCOUNT;
				syslog(LOG_NOTICE, "[left]foreward=%d turn[%d]", (int)forward, (int)turn);
			}
			else if(buf[0] == 'g' && mstate == MWAIT){
				mstate = MRUNNING;
			}
			else if(buf[0] == 's' && mstate == MRUNNING){
				mstate = MSTOP1;
				wtime = STOPWAIT;
			}
            else{
				int light = ecrobot_get_light_sensor(NXT_PORT_S3);
				syslog(LOG_NOTICE, "[display]foreward=%d turn[%d] gyio[%d] light[%d]", (int)forward, (int)turn, (int)distance, (int)light);
			}
		}
		key = ecrobot_get_touch_sensor(NXT_PORT_S4);
		if(key != keystate){	/* KEYZT[̌m */
			if(key != 0){
				if(mstate == MWAIT)
					mstate = MRUNNING;
				else if(mstate == MRUNNING){
					mstate = MSTOP1;
					wtime = STOPWAIT;
				}
			}
			keystate = key;
		}
		if(wtime > 0){
			if(--wtime <= 0 && mstate >= MSTOP1 && mstate < MPREWAIT){
				if(++mstate != MPREWAIT)
					wtime = 5;
			}
		}
		if(fore_count > 0){
			if(--fore_count == 0)
				forward = 0;
		}
		if(turn_count > 0){
			if(--turn_count == 0)
				turn = 0;
		}
		if(distance < 30 && forward > 0){
			syslog(LOG_NOTICE, "distance=%d foreward %d->0", distance, forward);
			ecrobot_sound_tone(500, 200, 100);
			fore_count = 2;
		}
		ecrobot_status_monitor("sample JSP"); /* LCD display */
		dly_tsk(40U); /* 40msec wait */
	}
}

