/**
 ******************************************************************************
 **	t@C : sample.c
 **
 **	Tv       : 2֓|UqCg[X{bgTOPPERS/JSPpTvvO
 **
 ******************************************************************************
 **/
#include <s_services.h>
#include "sample.h"

extern "C" {
#include "kernel_id.h"
#include "ecrobot_base.h"
#include "ecrobot_interface.h"
#include "balancer.h"	/* |Uqpwb_t@C */
}

/* L̃p[^̓ZT/ɍ킹ă`[jOKv܂ */
#define GYRO_OFFSET         589 /* WCZTItZbgl(px0[deg/sec])  */
#define WHITE               500 /* F̌ZTl */
#define BLACK		        700 /* F̌ZTl */
#define STOPWAIT            10	/* ~܂ł̎(*40ms) */

#define TAIL_ANGLE_STAND_UP 108 /* S~̊px[x] */
#define TAIL_ANGLE_DRIVE      0 /* oXs̊px[x] */
#define P_GAIN             2.5F /* S~p[^W */
#define PWM_ABS_MAX          60 /* S~p[^PWM΍ől */

static char mstate;				/* ŝ̏ */
static char keystate;			/* ^b`ZT[̏ */

//*****************************************************************************
// ֐ : tail_control
//   : angle ([^ڕWpx[x])
// Ԃl : 
// Tv : s̊S~p[^̊px
//*****************************************************************************
static void tail_control(signed int angle)
{
	float pwm = (float)(angle - nxt_motor_get_count(NXT_PORT_A))*P_GAIN; /* ᐧ */
	/* PWMo͖Oa */
	if(pwm > PWM_ABS_MAX)
		pwm = PWM_ABS_MAX;
	else if(pwm < -PWM_ABS_MAX)
		pwm = -PWM_ABS_MAX;
	nxt_motor_set_speed(NXT_PORT_A, (signed char)pwm, 1);
}

//*****************************************************************************
// TASK			: cyc0
// DESCRIPTION 	: 4msec periodical Task handler
//*****************************************************************************
void cyc0(VP_INT exinf)
{
	isig_sem(EVT_SEM);
}

//*****************************************************************************
// ^XN	: TaskMain
// Tv		: C^XN
//*****************************************************************************
void TaskMain(VP_INT exinf)
{
	signed char forward;      /* Oi: -100(i)`100(Oi)   */
	signed char turn;         /* 񖽗: -100()`100(E) */
	signed char pwm_L, pwm_R; /* E[^PWMo */

	mstate = MWAIT;
	ecrobot_set_light_sensor_active(NXT_PORT_S3);       /* ZTԐFLEDON */
	while (ecrobot_get_touch_sensor(NXT_PORT_S4) == 0){ /* ^b`ZTҋ@ */
		tail_control(TAIL_ANGLE_STAND_UP);	/* S~ppxɐ */
		dly_tsk(10);
	}

	balance_init();						/* |Uq䏉 */
	nxt_motor_set_count(NXT_PORT_C, 0); /* [^GR[_Zbg */
	nxt_motor_set_count(NXT_PORT_B, 0); /* E[^GR[_Zbg */
	forward = 50;						/* Oi */
	sta_cyc(CYC0);
	while(mstate < MPREWAIT){
		if(mstate == MRUNNING){
			tail_control(TAIL_ANGLE_DRIVE); /* oXsppxɐ */
			if (ecrobot_get_light_sensor(NXT_PORT_S3) >= (WHITE + BLACK)/2)
				turn = 50;  /* E */
			else
				turn = -50; /*  */
		}
		else if(mstate == MSTOP1){
			nxt_motor_set_count(NXT_PORT_A, 0);	/* S~p[^GR[_Zbg */
			mstate = MSTOP2;
		}
		else{
			tail_control(TAIL_ANGLE_STAND_UP);	/* S~ppxɐ */
			forward = 0;						/* ~ */
			turn = 0;
		}

		/* |Uq(forward = 0, turn = 0ŐÎ~oX) */
		balance_control(
			(float)forward,                              /* Oi                 */
			(float)turn,                                 /* 񖽗                   */
			(float)ecrobot_get_gyro_sensor(NXT_PORT_S1), /* WCZTl           */
			(float)GYRO_OFFSET,                          /* WCZTItZbgl */
			(float)nxt_motor_get_count(NXT_PORT_C),      /* [^]px[deg]      */
			(float)nxt_motor_get_count(NXT_PORT_B),      /* E[^]px[deg]      */
			(float)ecrobot_get_battery_voltage(),        /* obed[mV]           */
			&pwm_L,  /* [^PWMo͒l */
			&pwm_R); /* E[^PWMo͒l */
		nxt_motor_set_speed(NXT_PORT_C, pwm_L, 1); /* [^PWMo̓Zbg */
		nxt_motor_set_speed(NXT_PORT_B, pwm_R, 1); /* E[^PWMo̓Zbg */

		wai_sem(EVT_SEM);	/* 4MS҂ */
	}

	ecrobot_set_motor_speed(NXT_PORT_C, 0);      /* [^PWMo̓Zbg */
	ecrobot_set_motor_speed(NXT_PORT_B, 0);      /* E[^PWMo̓Zbg */
	ecrobot_sound_tone(1000, 200, 50);
	act_tsk(TASK0);
}

//*****************************************************************************
// ^XN	: TaskDisp
// Tv		: \^XN
//*****************************************************************************
void TaskDisp(VP_INT exinf)
{
	T_SERIAL_RPOR rpor;
	char buf[4];
	int wtime = 0;
	char key;
	ER ercd;

	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG));
	syscall(serial_ctl_por(CONSOLE_PORTID,	(IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV)));
	show_splash_screen();
	ecrobot_init_nxtstate();
	ecrobot_init_sensors();
	ecrobot_init_sonar_sensor(NXT_PORT_S2);
	show_main_screen();
	display_status_bar();
	ecrobot_sound_tone(1000, 200, 50);
	keystate = ecrobot_get_touch_sensor(NXT_PORT_S4);
	nxt_motor_set_count(NXT_PORT_A, 0);		/* S~p[^GR[_Zbg */
	act_tsk(TASK0);
	while(1){
		ecrobot_poll_nxtstate();
		ercd = serial_ref_por(CONSOLE_PORTID, &rpor);
		if(ercd == E_OK && rpor.reacnt){
			serial_rea_dat(CONSOLE_PORTID, buf, 1);
			if(buf[0] == 'g' && mstate == MWAIT){
				mstate = MRUNNING;
			}
			else if(buf[0] == 's' && mstate == MRUNNING){
				mstate = MSTOP1;
				wtime = STOPWAIT;
			}
		}
		key = ecrobot_get_touch_sensor(NXT_PORT_S4);
		if(key != keystate){	/* KEYZT[̌m */
			if(key != 0){
				if(mstate == MWAIT)
					mstate = MRUNNING;
				else if(mstate == MRUNNING){
					mstate = MSTOP1;
					wtime = STOPWAIT;
				}
			}
			keystate = key;
		}
		if(wtime > 0){
			if(--wtime <= 0 && mstate >= MSTOP1 && mstate < MPREWAIT){
				if(++mstate != MPREWAIT)
					wtime = 1;
			}
		}

		ecrobot_status_monitor((const S8*)"sample JSP"); /* LCD display */
		dly_tsk(40U); /* 40msec wait */
	}
}

