/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Takagi Nobuhisa
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: newlibrt.c,v 1.2 2004/09/17 09:11:44 honda Exp $
 */
#include <stddef.h>
#include <reent.h>
#include <errno.h>
#include <stdio.h>
#include "../kernel/jsp_kernel.h"

#ifndef	HEAP_TOP
#define	HEAP_TOP		~0UL
#endif

/* C++ constructor/destructor table */
extern void (*__ctor_begin[])(void);
extern void (*__ctor_end)(void);
extern void (*__dtor_begin[])(void);
extern void (*__dtor_end)(void);

/*
 *	For malloc (Newlib)
 */
static int cxxrt_dis_dsp;

void __malloc_lock(struct _reent *ptr)
{
	if (!iniflg || sns_dsp())
		return;
	dis_dsp();
	cxxrt_dis_dsp = 1;
}

void __malloc_unlock(struct _reent *ptr)
{
	if (!cxxrt_dis_dsp)
		return;
	cxxrt_dis_dsp = 0;
	ena_dsp();
}

void *_sbrk_r(struct _reent *ptr, ptrdiff_t nbyte)
{
	extern char end;
	static char *heap_ptr = &end;
	static char *heap_end = (char*)HEAP_TOP;
	char *base;

	if (!iniflg)
	{
		volatile char _auto;
		if (&end < &_auto && &_auto < heap_end)
			heap_end = (char*)&_auto;
	}

	if (heap_ptr + nbyte + 32 > heap_end)
	{
		ptr->_errno = errno = ENOMEM;
		return (void*)-1;
	}

	base = heap_ptr;
	heap_ptr += nbyte;
	return base;
}

/*
 * ɸϤ (Newlib)
 */

static ID   dummyid = CONSOLE_PORTID;
static ID * stdport = &dummyid;

int _fstat_r(struct _reent *ptr, int fd, struct stat *pstat)
{
	return 0;
}

off_t _lseek_r(struct _reent *ptr, int fd, off_t pos, int whence)
{
	return pos;
}

_ssize_t _read_r(struct _reent *ptr, int fd, _PTR buf, size_t cnt)
{
	_ssize_t len = 1;

	serial_rea_dat(*stdport, buf, len);
	return len;
}

_ssize_t _write_r(struct _reent *ptr, int fd, _CONST _PTR buf, size_t cnt)
{
	char *b = (char *)buf;
	char sbuf[10];
	int i, len;

	for(i = len = 0 ; i < cnt ; i++){
		if(b[i] == '\n')
			sbuf[len++] = '\r';
		if(b[i] > 0){
			sbuf[len++] = b[i];
			if(len >= 8){
				serial_wri_dat(*stdport, sbuf, len);
				len = 0;
			}
		}
	}
	if(len > 0)
		serial_wri_dat(*stdport, sbuf, len);
	return i;
}

int _close_r(struct _reent *ptr, int fd)
{
	return 0;
}

#ifndef _SMALL_STDIO_
/*
 *  ɸϽؿ
 */
void _setup_stdio(ID *pport)
{
	stdport = pport;
	setbuf(stdout, 0);
}

#endif

#ifndef NO_CPP
/*
 *	For program termination
 */
#define	ATEXIT_MAX	(32 + 1)

static void (*atexit_table[ATEXIT_MAX])(void);
static int atexit_num;

/*
 * abort˺ǽ˸ƽФեå
 * raise(SIGABRT)ƽФ褦ˤСۥȴĶȤθߴȤ뤳Ȥǽˤʤ롣
 */
void (*_atabort)(void) = 0;

int atexit(void (*func)(void))
{
	int result = -1;
	int sync = iniflg;

	if (sync)
		loc_cpu();

	if (atexit_num < ATEXIT_MAX)
	{
		atexit_table[atexit_num++] = func;
		result = 0;
	}

	if (sync)
		unl_cpu();

	return result;
}

void exit(int status)
{
	if (iniflg)
		kernel_exit();
	_exit(status);
}

void abort(void)
{
	if (_atabort != 0)
		(*_atabort)();
	if (iniflg)
		kernel_abort();
	_exit(3);
}

/*
 *	For software hooks
 */
void software_init_hook(void)
{
	extern void _toppers_cxxrt_init(void);
	_toppers_cxxrt_init();
	{
		int i;
	    /* call all global object constructors */
    	for (i=0;__ctor_begin[i] != __ctor_end;i++)
      	(*__ctor_begin[i])();
	}
}

void software_term_hook(void)
{
	int i;

    /* call all global object destructors */
    for (i=0;__dtor_begin[i] != __dtor_end;i++)
      (*__dtor_begin[i])();

	for (i = atexit_num - 1; i >= 0; i--)
		(*atexit_table[i])();
}

#endif	/* NO_CPP */

