/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2009 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: rtos.h,v 1.1 2009/12/05 09:14:24 roi Exp $
 */

#ifndef _RTOS_H_
#define _RTOS_H_

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "arm_gcc/at91sam7s/at91sam7s.h"
#include "mindstormsnxt.h"
#include <itron.h>
#include <sil.h>
#include "../syssvc/logtask.h"

/*
 *  TC0γߥϥɥΥ٥ֹ
 */
#define INHNO_TC0        INTNO_TC0_PID /* ߥϥɥֹ */
#define INTNO_TC0        INTNO_TC0_PID /* ֹ */
#define INTPRI_TC0       -4            /* ͥ */
#define INTATR_TC0       0             /* ° */
#define IRQ_TC0_PID      INTNO_TC0_PID

/*
 *  SPIγߥϥɥΥ٥ֹ
 */
#define INHNO_SPI        INTNO_SPI_PID /* ߥϥɥֹ */
#define INTNO_SPI        INTNO_SPI_PID /* ֹ */
#define INTPRI_SPI       -4            /* ͥ */
#define INTATR_SII       0             /* ° */
#define IRQ_SPI_PID      INTNO_SPI_PID

/*
 *  TWIγߥϥɥΥ٥ֹ
 */
#define INHNO_TWI        INTNO_TWI_PID /* ߥϥɥֹ */
#define INTNO_TWI        INTNO_TWI_PID /* ֹ */
#define INTPRI_TWI       -5            /* ͥ */
#define INTATR_TWI       0U            /* ° */
#define IRQ_TWI_PID      INTNO_TWI_PID

/*
 *  SPIγߥϥɥΥ٥ֹ
 */
#define INHNO_PIOA       INTNO_PIOA_PID /* ߥϥɥֹ */
#define INTNO_PIOA       INTNO_PIOA_PID /* ֹ */
#define INTPRI_PIOA      -4            /* ͥ */
#define INTATR_PIOA      0U            /* ° */
#define IRQ_PIOA_PID     INTNO_PIOA_PID

/*
 *  SPIγߥϥɥΥ٥ֹ
 */
#define INHNO_SPI        INTNO_SPI_PID /* ߥϥɥֹ */
#define INTNO_SPI        INTNO_SPI_PID /* ֹ */
#define INTPRI_SPI       -4            /* ͥ */
#define INTATR_SPI       0U            /* ° */

/*
 *  PWMγߥϥɥΥ٥ֹ
 */
#define INHNO_PWM        INTNO_PWM_PID /* ߥϥɥֹ */
#define INTNO_PWM        INTNO_PWM_PID /* ֹ */
#define INTPRI_PWM       -2            /* ͥ */
#define INTATR_PWM       TA_EDGE       /* ° */
#define IRQ_PWM_PID      INTNO_PWM_PID

/*
 *  SCCγߥϥɥΥ٥ֹ
 */
#define INHNO_SSC        INTNO_SSC_PID /* ߥϥɥֹ */
#define INTNO_SSC        INTNO_SSC_PID /* ֹ */
#define INTPRI_SSC       -1            /* ͥ */
#define INTATR_SSC       TA_EDGE       /* ° */
#define IRQ_SSC_PID      INTNO_SSC_PID

#define IRQ_UDP_PID      INTNO_UDP_PID
#define IRQ_US0_PID      INTNO_US0_PID
#define IRQ_US1_PID      INTNO_US1_PID

#ifndef _MACRO_ONLY

#include "mytypes.h"

#ifndef CONSOLE_PORTID
#define CONSOLE_PORTID     LOGTASK_PORTID
#endif

#define NXT_AVR_TIMERID      0
#define NXT_MOTOR_TIMERID    1
#define NUM_NXT_TIMER        2

#define kernel_exit             ext_ker

#define aic_mask_on(a)          sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_IECR), 1<<a);
#define aic_mask_off(a)         sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_IDCR), 1<<a);
#define aic_clear(a)            sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_ICCR), 1<<a);

#define systick_wait_ms(a)      dly_tsk(a)
#define systick_wait_ns(a)      sil_dly_nse(a*1000)
#define systick_suspend()       aic_mask_off(IRQ_PWM_PID)
#define systick_resume()        aic_mask_on(IRQ_PWM_PID)

#define set_time_func(no, func) rtos_1kHz_time_func[no] = func

extern void (*rtos_1kHz_time_func[NUM_NXT_TIMER])(void);

extern void twi_isr_C(void);
extern void spi_isr_C(void);
extern void i2c_timer_isr_C(void);
extern void nxt_motor_isr_C(void);
extern void sound_isr_C(void);

extern void i2c_init(long exinf);
extern void nxt_motor_init(long exinf);
extern void nxt_avr_init(long exinf);
extern void display_init(long exinf);
extern void sound_init(long exinf);

extern void rtos_init(long exinf);
extern void rtos_1kHz_process(long exinf);

#endif /* _MACRO_ONLY */
#endif /* _RTOS_H_ */



